    .486

CODE segment para public 'CODE' use16

    assume cs:CODE,ds:CODE,es:CODE,ss:NOTHING,FS:NOTHING,GS:NOTHING

    org  0100h
start:    
    mov  ax,013h
    int  010h
    mov  dx,03C8h
    xor  al,al
    out  dx,al
    inc  dx
pal:
    mov  al,ah
    cmp  al,03Fh
    jbe  nobigger
    mov  al,03Fh
nobigger:
    out  dx,al
    mov  al,ah
    shr  al,2
    out  dx,al
    mov  al,ah
    shr  al,1
    sub  al,03Fh
    jge  nonegative
    xor  al,al
nonegative:
    out  dx,al
    inc  ah
    jne  pal

    mov  bp,cs
    add  bp,01000h
    mov  ds,bp
    mov  es,bp
    xor  ax,ax
    mov  fs,ax
    mov  di,ax
    mov  cx,65535
    rep  stosw
    mov  ah,0F0h
    mov  gs,ax
mainloop:
    mov  cl,5
loop1:
    call rand
    xor  ah,ah
    mov  di,ax
    add  di,199*320+(320-256)/2
    call rand
    stosb
    stosb
    loop loop1
    xor  di,di
    mov  cx,320*199
loop2:
    xor  ax,ax
    xor  bx,bx
    mov  bl,[di+319]
    mov  al,[di+320]
    add  bx,ax
    mov  al,[di+321]
    add  bx,ax
    shl  bx,1
    mov  al,[di-1]
    add  bx,ax
    mov  al,[di+1]
    add  bx,ax
    sub  bx,3
    jge  noneg2
    xor  bx,bx
noneg2:
    shr  bx,3
    mov  [di],bl
    inc  di
    loop loop2

    test byte ptr fs:[046Ch],32
    je   nodraw
    mov  si,0FA6Eh+'2'*8
    mov  di,(200-64)/2*320+(320-64*3)/2+8
    call big
    mov  si,0FA6Eh+'5'*8
    call big
    call big
nodraw:

    mov  ax,0A000h
    mov  es,ax
    xor  si,si
    xor  di,di
    mov  cx,320*200/2
    rep  movsw
    push ds
    pop  es
    in   al,060h
    dec  al
    jne  mainloop
    mov  ax,3
    int  10h
    ret

rand:
    mov  ax,16
randloop:    
    rol  bp,1
    jc   noxor
    xor  bp,44
noxor:
    dec  ax
    jne  randloop
    mov  ax,bp
    ret
    
big:
    mov  dh,64
rowloop1:
    mov  dl,8
    mov  ah,gs:[si]
rowloop:
    rol  ah,1
    sbb  al,al
    lea  bx,[di+8]
    mov  cl,8
    and  cl,al
    rep  stosb
    mov  di,bx
    dec  dl
    jne  rowloop
    add  di,320-64
    dec  dh
    test dh,7
    jne  nonext
    inc  si
nonext:
    test dh,dh
    jne  rowloop1
    sub  di,320*64-64
    ret

code ends
    end start
